com.holonplatform.vaadin.components

## Interface Components

-     public interface Components

  Main provider of UI components builders and configurators.

  Provides static methods to obtain builder for common UI components type, allowing fluent and implementation-agnostic components creation and configuration.

  Since:
    5.0.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `Components.input` `Input`, `PropertyInputGroup` and `PropertyInputForm` builders provider.
    `static interface` | `Components.listing` `ItemListing` builders provider.
    `static interface` | `Components.view` `ViewComponent` and `PropertyViewGroup` builders provider.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `SCROLLABLE_STYLENAME` CSS style name to render a Component as scrollable

  - ### Method Summary

    All Methods Static Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static TabsBuilder<com.vaadin.ui.Accordion>` | `accordion()` Gets a builder to create an `Accordion`.
    `static ButtonBuilder` | `button()` Gets a builder to create `Button`s.
    `static ButtonBuilder` | `button(boolean nativeMode)` Gets a builder to create `Button`s
    `static ClickableLayoutConfigurator.BaseClickableLayoutConfigurator` | `configure(com.vaadin.ui.AbsoluteLayout layout)` Get a `ClickableLayoutConfigurator` to configure given layout.
    `static ComponentConfigurator.BaseComponentConfigurator` | `configure(com.vaadin.ui.AbstractComponent component)` Get a `ComponentConfigurator` to configure given component.
    `static <T> InputConfigurator.BaseFieldConfigurator<T>` | `configure(com.vaadin.ui.AbstractField<T> field)` Get a `InputConfigurator` to configure given field.
    `static ButtonConfigurator.BaseButtonConfigurator` | `configure(com.vaadin.ui.Button button)` Get a `ButtonConfigurator` to configure given button.
    `static ClickableLayoutConfigurator.BaseClickableLayoutConfigurator` | `configure(com.vaadin.ui.CssLayout layout)` Get a `ClickableLayoutConfigurator` to configure given layout.
    `static OrderedLayoutConfigurator.BaseOrderedLayoutConfigurator` | `configure(com.vaadin.ui.FormLayout layout)` Get a `OrderedLayoutConfigurator` to configure given layout.
    `static LayoutConfigurator.BaseLayoutConfigurator` | `configure(com.vaadin.ui.GridLayout layout)` Get a `LayoutConfigurator` to configure given layout.
    `static OrderedLayoutConfigurator.BaseOrderedLayoutConfigurator` | `configure(com.vaadin.ui.HorizontalLayout layout)` Get a `OrderedLayoutConfigurator` to configure given layout.
    `static LabelConfigurator.BaseLabelConfigurator` | `configure(com.vaadin.ui.Label label)` Get a `LabelConfigurator` to configure given label.
    `static OrderedLayoutConfigurator.BaseOrderedLayoutConfigurator` | `configure(com.vaadin.ui.VerticalLayout layout)` Get a `OrderedLayoutConfigurator` to configure given layout.
    `static CssLayoutBuilder` | `cssLayout()` Gets a builder to create `CssLayout`s.
    `static Dialog.DialogBuilder` | `dialog()` Gets a builder to create and open a `Dialog` window.
    `static com.vaadin.ui.Component` | `filler()` Build a filler component, i.e. a `Label` with undefined size and the HTML entity `` as content, which can be used with full expand ratio as a space filler in layouts.
    `static FormLayoutBuilder` | `formLayout()` Gets a builder to create `FormLayout`s.
    `static GridLayoutBuilder` | `gridLayout()` Gets a builder to create `FormLayout`s.
    `static GridLayoutBuilder` | `gridLayout(int columns, int rows)` Gets a builder to create `GridLayout`s.
    `static HorizontalLayoutBuilder` | `hl()` Gets a builder to create `HorizontalLayout`s.
    `static LabelBuilder` | `label()` Gets a builder to create `Label`s.
    `static PanelBuilder` | `panel()` Gets a builder to create `Panel`s.
    `static Dialog.QuestionDialogBuilder` | `questionDialog()` Gets a builder to create and open a question `Dialog` window.
    `static TabsBuilder<com.vaadin.ui.TabSheet>` | `tabSheet()` Gets a builder to create a `TabSheet`.
    `static VerticalLayoutBuilder` | `vl()` Gets a builder to create `VerticalLayout`s.

- - ### Field Detail

    - #### SCROLLABLE_STYLENAME

          static final String SCROLLABLE_STYLENAME

      CSS style name to render a Component as scrollable
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### configure

          static ComponentConfigurator.BaseComponentConfigurator configure(com.vaadin.ui.AbstractComponent component)

      Get a `ComponentConfigurator` to configure given component.
      Parameters:
        `component` - Component to configure (not null)
      Returns:
        BaseComponentConfigurator

    - #### configure

          static LabelConfigurator.BaseLabelConfigurator configure(com.vaadin.ui.Label label)

      Get a `LabelConfigurator` to configure given label.
      Parameters:
        `label` - Label to configure (not null)
      Returns:
        BaseLabelConfigurator

    - #### configure

          static ButtonConfigurator.BaseButtonConfigurator configure(com.vaadin.ui.Button button)

      Get a `ButtonConfigurator` to configure given button.
      Parameters:
        `button` - Button to configure (not null)
      Returns:
        BaseButtonConfigurator

    - #### configure

          static <T> InputConfigurator.BaseFieldConfigurator<T> configure(com.vaadin.ui.AbstractField<T> field)

      Get a `InputConfigurator` to configure given field.
      Type Parameters:
        `T` - Field type
      Parameters:
        `field` - Field to configure (not null)
      Returns:
        BaseFieldConfigurator

    - #### configure

          static OrderedLayoutConfigurator.BaseOrderedLayoutConfigurator configure(com.vaadin.ui.VerticalLayout layout)

      Get a `OrderedLayoutConfigurator` to configure given layout.
      Parameters:
        `layout` - Layout to configure
      Returns:
        Layout configurator

    - #### configure

          static OrderedLayoutConfigurator.BaseOrderedLayoutConfigurator configure(com.vaadin.ui.HorizontalLayout layout)

      Get a `OrderedLayoutConfigurator` to configure given layout.
      Parameters:
        `layout` - Layout to configure
      Returns:
        Layout configurator

    - #### configure

          static OrderedLayoutConfigurator.BaseOrderedLayoutConfigurator configure(com.vaadin.ui.FormLayout layout)

      Get a `OrderedLayoutConfigurator` to configure given layout.
      Parameters:
        `layout` - Layout to configure
      Returns:
        Layout configurator

    - #### configure

          static LayoutConfigurator.BaseLayoutConfigurator configure(com.vaadin.ui.GridLayout layout)

      Get a `LayoutConfigurator` to configure given layout.
      Parameters:
        `layout` - Layout to configure
      Returns:
        Layout configurator

    - #### configure

          static ClickableLayoutConfigurator.BaseClickableLayoutConfigurator configure(com.vaadin.ui.CssLayout layout)

      Get a `ClickableLayoutConfigurator` to configure given layout.
      Parameters:
        `layout` - Layout to configure
      Returns:
        Layout configurator

    - #### configure

          static ClickableLayoutConfigurator.BaseClickableLayoutConfigurator configure(com.vaadin.ui.AbsoluteLayout layout)

      Get a `ClickableLayoutConfigurator` to configure given layout.
      Parameters:
        `layout` - Layout to configure
      Returns:
        Layout configurator

    - #### filler

          static com.vaadin.ui.Component filler()

      Build a filler component, i.e. a `Label` with undefined size and the HTML entity `` as content, which can be used with full expand ratio as a space filler in layouts.
      Returns:
        Filler

    - #### label

          static LabelBuilder label()

      Gets a builder to create `Label`s.

      The Label is of undefined size by default.

      Returns:
        Label builder

    - #### button

          static ButtonBuilder button()

      Gets a builder to create `Button`s.
      Returns:
        Button builder

    - #### button

          static ButtonBuilder button(boolean nativeMode)

      Gets a builder to create `Button`s
      Parameters:
        `nativeMode` - `true` to create a "native" button, i.e. implemented using the native button of web browsers, using the HTML `<button>` element.
      Returns:
        Button builder

    - #### cssLayout

          static CssLayoutBuilder cssLayout()

      Gets a builder to create `CssLayout`s.
      Returns:
        CssLayout builder

    - #### formLayout

          static FormLayoutBuilder formLayout()

      Gets a builder to create `FormLayout`s.
      Returns:
        FormLayout builder

    - #### gridLayout

          static GridLayoutBuilder gridLayout()

      Gets a builder to create `FormLayout`s.
      Returns:
        FormLayout builder

    - #### gridLayout

          static GridLayoutBuilder gridLayout(int columns,
                                              int rows)

      Gets a builder to create `GridLayout`s.
      Parameters:
        `columns` - Initial number of columns
        `rows` - Initial number of rows
      Returns:
        GridLayout builder

    - #### hl

          static HorizontalLayoutBuilder hl()

      Gets a builder to create `HorizontalLayout`s.
      Returns:
        HorizontalLayout builder

    - #### vl

          static VerticalLayoutBuilder vl()

      Gets a builder to create `VerticalLayout`s.
      Returns:
        VerticalLayout builder

    - #### panel

          static PanelBuilder panel()

      Gets a builder to create `Panel`s.
      Returns:
        Panel builder

    - #### tabSheet

          static TabsBuilder<com.vaadin.ui.TabSheet> tabSheet()

      Gets a builder to create a `TabSheet`.
      Returns:
        TabSheet builder

    - #### accordion

          static TabsBuilder<com.vaadin.ui.Accordion> accordion()

      Gets a builder to create an `Accordion`.
      Returns:
        Accordion builder

    - #### dialog

          static Dialog.DialogBuilder dialog()

      Gets a builder to create and open a `Dialog` window. The dialog will present by default a single ok button.
      Returns:
        DialogBuilder

    - #### questionDialog

          static Dialog.QuestionDialogBuilder questionDialog()

      Gets a builder to create and open a question `Dialog` window. The dialog will present by default a yes and a no button. Use `Dialog.QuestionDialogBuilder.callback(com.holonplatform.vaadin.components.Dialog.QuestionCallback)` to handle the user selected answer.
      Returns:
        QuestionDialogBuilder

Copyright © 2019 The Holon Platform. All rights reserved.